# AUTOMATICALLY GENERATED by `shtab`

_shtab_gitlabci_subparsers=('completion' 'autoscaler' 'create' 'dashboard' 'destroy' 'jobs' 'monitoring' 'runner' 'hardening' 'status' 'ssh')
_shtab_gitlabci_autoscaler_subparsers=('deploy' 'status' 'purge')
_shtab_gitlabci_create_subparsers=('aws' 'ssh')
_shtab_gitlabci_dashboard_subparsers=('deploy' 'get-token' 'purge')
_shtab_gitlabci_destroy_subparsers=('aws' 'ssh')
_shtab_gitlabci_jobs_subparsers=('list')
_shtab_gitlabci_monitoring_subparsers=('deploy' 'get-admin-password' 'purge')
_shtab_gitlabci_runner_subparsers=('deploy' 'list' 'purge')
_shtab_gitlabci_hardening_subparsers=('deploy')

_shtab_gitlabci_option_strings=('-h' '--help')
_shtab_gitlabci_completion_option_strings=('-h' '--help')
_shtab_gitlabci_autoscaler_option_strings=('-h' '--help')
_shtab_gitlabci_autoscaler_deploy_option_strings=('-h' '--help')
_shtab_gitlabci_autoscaler_status_option_strings=('-h' '--help')
_shtab_gitlabci_autoscaler_purge_option_strings=('-h' '--help')
_shtab_gitlabci_create_option_strings=('-h' '--help')
_shtab_gitlabci_create_aws_option_strings=('-h' '--help' '--kubernetes-version' '--enable-metrics' '--enable-autoscaler')
_shtab_gitlabci_create_ssh_option_strings=('-h' '--help' '--kubernetes-version')
_shtab_gitlabci_dashboard_option_strings=('-h' '--help')
_shtab_gitlabci_dashboard_deploy_option_strings=('-h' '--help')
_shtab_gitlabci_dashboard_get_token_option_strings=('-h' '--help')
_shtab_gitlabci_dashboard_purge_option_strings=('-h' '--help')
_shtab_gitlabci_destroy_option_strings=('-h' '--help')
_shtab_gitlabci_destroy_aws_option_strings=('-h' '--help')
_shtab_gitlabci_destroy_ssh_option_strings=('-h' '--help')
_shtab_gitlabci_jobs_option_strings=('-h' '--help')
_shtab_gitlabci_jobs_list_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_monitoring_option_strings=('-h' '--help')
_shtab_gitlabci_monitoring_deploy_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_monitoring_get_admin_password_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_monitoring_purge_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_runner_option_strings=('-h' '--help')
_shtab_gitlabci_runner_deploy_option_strings=('-h' '--help' '--namespace' '--token' '--config')
_shtab_gitlabci_runner_list_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_runner_purge_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_hardening_option_strings=('-h' '--help')
_shtab_gitlabci_hardening_deploy_option_strings=('-h' '--help' '--inventory' '--playbook' '--interactive')
_shtab_gitlabci_status_option_strings=('-h' '--help' '--namespace')
_shtab_gitlabci_ssh_option_strings=('-h' '--help')

_shtab_gitlabci_runner_deploy___config_COMPGEN=_shtab_compgen_files

_shtab_gitlabci_pos_0_choices=('completion' 'autoscaler' 'create' 'dashboard' 'destroy' 'jobs' 'monitoring' 'runner' 'hardening' 'status' 'ssh')
_shtab_gitlabci_completion_pos_0_choices=('bash' 'zsh' 'tcsh')
_shtab_gitlabci_autoscaler_pos_0_choices=('deploy' 'status' 'purge')
_shtab_gitlabci_create_pos_0_choices=('aws' 'ssh')
_shtab_gitlabci_dashboard_pos_0_choices=('deploy' 'get-token' 'purge')
_shtab_gitlabci_destroy_pos_0_choices=('aws' 'ssh')
_shtab_gitlabci_jobs_pos_0_choices=('list')
_shtab_gitlabci_monitoring_pos_0_choices=('deploy' 'get-admin-password' 'purge')
_shtab_gitlabci_runner_pos_0_choices=('deploy' 'list' 'purge')
_shtab_gitlabci_hardening_pos_0_choices=('deploy')

_shtab_gitlabci_pos_0_nargs=A...
_shtab_gitlabci__h_nargs=0
_shtab_gitlabci___help_nargs=0
_shtab_gitlabci_completion__h_nargs=0
_shtab_gitlabci_completion___help_nargs=0
_shtab_gitlabci_autoscaler_pos_0_nargs=A...
_shtab_gitlabci_autoscaler__h_nargs=0
_shtab_gitlabci_autoscaler___help_nargs=0
_shtab_gitlabci_autoscaler_deploy__h_nargs=0
_shtab_gitlabci_autoscaler_deploy___help_nargs=0
_shtab_gitlabci_autoscaler_status__h_nargs=0
_shtab_gitlabci_autoscaler_status___help_nargs=0
_shtab_gitlabci_autoscaler_purge__h_nargs=0
_shtab_gitlabci_autoscaler_purge___help_nargs=0
_shtab_gitlabci_create_pos_0_nargs=A...
_shtab_gitlabci_create__h_nargs=0
_shtab_gitlabci_create___help_nargs=0
_shtab_gitlabci_create_aws__h_nargs=0
_shtab_gitlabci_create_aws___help_nargs=0
_shtab_gitlabci_create_aws___enable_metrics_nargs=0
_shtab_gitlabci_create_aws___enable_autoscaler_nargs=0
_shtab_gitlabci_create_ssh__h_nargs=0
_shtab_gitlabci_create_ssh___help_nargs=0
_shtab_gitlabci_dashboard_pos_0_nargs=A...
_shtab_gitlabci_dashboard__h_nargs=0
_shtab_gitlabci_dashboard___help_nargs=0
_shtab_gitlabci_dashboard_deploy__h_nargs=0
_shtab_gitlabci_dashboard_deploy___help_nargs=0
_shtab_gitlabci_dashboard_get_token__h_nargs=0
_shtab_gitlabci_dashboard_get_token___help_nargs=0
_shtab_gitlabci_dashboard_purge__h_nargs=0
_shtab_gitlabci_dashboard_purge___help_nargs=0
_shtab_gitlabci_destroy_pos_0_nargs=A...
_shtab_gitlabci_destroy__h_nargs=0
_shtab_gitlabci_destroy___help_nargs=0
_shtab_gitlabci_destroy_aws__h_nargs=0
_shtab_gitlabci_destroy_aws___help_nargs=0
_shtab_gitlabci_destroy_ssh__h_nargs=0
_shtab_gitlabci_destroy_ssh___help_nargs=0
_shtab_gitlabci_jobs_pos_0_nargs=A...
_shtab_gitlabci_jobs__h_nargs=0
_shtab_gitlabci_jobs___help_nargs=0
_shtab_gitlabci_jobs_list__h_nargs=0
_shtab_gitlabci_jobs_list___help_nargs=0
_shtab_gitlabci_monitoring_pos_0_nargs=A...
_shtab_gitlabci_monitoring__h_nargs=0
_shtab_gitlabci_monitoring___help_nargs=0
_shtab_gitlabci_monitoring_deploy__h_nargs=0
_shtab_gitlabci_monitoring_deploy___help_nargs=0
_shtab_gitlabci_monitoring_get_admin_password__h_nargs=0
_shtab_gitlabci_monitoring_get_admin_password___help_nargs=0
_shtab_gitlabci_monitoring_purge__h_nargs=0
_shtab_gitlabci_monitoring_purge___help_nargs=0
_shtab_gitlabci_runner_pos_0_nargs=A...
_shtab_gitlabci_runner__h_nargs=0
_shtab_gitlabci_runner___help_nargs=0
_shtab_gitlabci_runner_deploy__h_nargs=0
_shtab_gitlabci_runner_deploy___help_nargs=0
_shtab_gitlabci_runner_list__h_nargs=0
_shtab_gitlabci_runner_list___help_nargs=0
_shtab_gitlabci_runner_purge_pos_0_nargs=+
_shtab_gitlabci_runner_purge__h_nargs=0
_shtab_gitlabci_runner_purge___help_nargs=0
_shtab_gitlabci_hardening_pos_0_nargs=A...
_shtab_gitlabci_hardening__h_nargs=0
_shtab_gitlabci_hardening___help_nargs=0
_shtab_gitlabci_hardening_deploy__h_nargs=0
_shtab_gitlabci_hardening_deploy___help_nargs=0
_shtab_gitlabci_hardening_deploy___interactive_nargs=0
_shtab_gitlabci_status__h_nargs=0
_shtab_gitlabci_status___help_nargs=0
_shtab_gitlabci_ssh__h_nargs=0
_shtab_gitlabci_ssh___help_nargs=0


# $1=COMP_WORDS[1]
_shtab_compgen_files() {
  compgen -f -- $1  # files
}

# $1=COMP_WORDS[1]
_shtab_compgen_dirs() {
  compgen -d -- $1  # recurse into subdirs
}

# $1=COMP_WORDS[1]
_shtab_replace_nonword() {
  echo "${1//[^[:word:]]/_}"
}

# set default values (called for the initial parser & any subparsers)
_set_parser_defaults() {
  local subparsers_var="${prefix}_subparsers[@]"
  sub_parsers=${!subparsers_var-}

  local current_option_strings_var="${prefix}_option_strings[@]"
  current_option_strings=${!current_option_strings_var}

  completed_positional_actions=0

  _set_new_action "pos_${completed_positional_actions}" true
}

# $1=action identifier
# $2=positional action (bool)
# set all identifiers for an action's parameters
_set_new_action() {
  current_action="${prefix}_$(_shtab_replace_nonword $1)"

  local current_action_compgen_var=${current_action}_COMPGEN
  current_action_compgen="${!current_action_compgen_var-}"

  local current_action_choices_var="${current_action}_choices[@]"
  current_action_choices="${!current_action_choices_var-}"

  local current_action_nargs_var="${current_action}_nargs"
  if [ -n "${!current_action_nargs_var-}" ]; then
    current_action_nargs="${!current_action_nargs_var}"
  else
    current_action_nargs=1
  fi

  current_action_args_start_index=$(( $word_index + 1 - $pos_only ))

  current_action_is_positional=$2
}

# Notes:
# `COMPREPLY`: what will be rendered after completion is triggered
# `completing_word`: currently typed word to generate completions for
# `${!var}`: evaluates the content of `var` and expand its content as a variable
#     hello="world"
#     x="hello"
#     ${!x} -> ${hello} -> "world"
_shtab_gitlabci() {
  local completing_word="${COMP_WORDS[COMP_CWORD]}"
  local completed_positional_actions
  local current_action
  local current_action_args_start_index
  local current_action_choices
  local current_action_compgen
  local current_action_is_positional
  local current_action_nargs
  local current_option_strings
  local sub_parsers
  COMPREPLY=()

  local prefix=_shtab_gitlabci
  local word_index=0
  local pos_only=0 # "--" delimeter not encountered yet
  _set_parser_defaults
  word_index=1

  # determine what arguments are appropriate for the current state
  # of the arg parser
  while [ $word_index -ne $COMP_CWORD ]; do
    local this_word="${COMP_WORDS[$word_index]}"

    if [[ $pos_only = 1 || " $this_word " != " -- " ]]; then
      if [[ -n $sub_parsers && " ${sub_parsers[@]} " == *" ${this_word} "* ]]; then
        # valid subcommand: add it to the prefix & reset the current action
        prefix="${prefix}_$(_shtab_replace_nonword $this_word)"
        _set_parser_defaults
      fi

      if [[ " ${current_option_strings[@]} " == *" ${this_word} "* ]]; then
        # a new action should be acquired (due to recognised option string or
        # no more input expected from current action);
        # the next positional action can fill in here
        _set_new_action $this_word false
      fi

      if [[ "$current_action_nargs" != "*" ]] && \
         [[ "$current_action_nargs" != "+" ]] && \
         [[ "$current_action_nargs" != *"..." ]] && \
         (( $word_index + 1 - $current_action_args_start_index - $pos_only >= \
            $current_action_nargs )); then
        $current_action_is_positional && let "completed_positional_actions += 1"
        _set_new_action "pos_${completed_positional_actions}" true
      fi
    else
      pos_only=1 # "--" delimeter encountered
    fi

    let "word_index+=1"
  done

  # Generate the completions

  if [[ $pos_only = 0 && "${completing_word}" == -* ]]; then
    # optional argument started: use option strings
    COMPREPLY=( $(compgen -W "${current_option_strings[*]}" -- "${completing_word}") )
  else
    # use choices & compgen
    local IFS=$'\n' # items may contain spaces, so delimit using newline
    COMPREPLY=( $([ -n "${current_action_compgen}" ] \
                  && "${current_action_compgen}" "${completing_word}") )
    unset IFS
    COMPREPLY+=( $(compgen -W "${current_action_choices[*]}" -- "${completing_word}") )
  fi

  return 0
}

complete -o filenames -F _shtab_gitlabci gitlabci
